/**
 * @file          ks-license-gui/src/va/interface/ksl-va.h
 * @brief
 * @author        xiaowen <xiaowen@kylinos.com.cn>
 * @copyright (c) 2023 KylinSec. All rights reserved.
 */
#ifndef KSLVA_H
#define KSLVA_H

#include <QIcon>
#include <QVBoxLayout>
#include <QWidget>
#include "ks-license/license-i.h"

namespace Ui
{
class KslVA;
}
class QTranslator;

namespace VA
{
class ActiveGuide;
}

class KslVA : public QWidget
{
    Q_OBJECT

public:
    explicit KslVA(const QString &ObjectName, const QIcon &icon, QWidget *parent = NULL);
    static LicenseActivationStatus getLicenseState(const QString &ObjectName, QString &error);
    static time_t getExpiryTime(const QString &ObjectName, QString &error);

protected:
    void mousePressEvent(QMouseEvent *event);
    void mouseMoveEvent(QMouseEvent *event);
    void mouseReleaseEvent(QMouseEvent *event);

private:
    void initUi();
    ~KslVA();
    void setWidget(QWidget *widget);
    void setTitle(const QString &title);

private slots:
    void on_exit_clicked();
    void on_minimize_clicked();

    void on_sigAcived(time_t expiryDay);
    void onSigCLose();

signals:
    void sigActived(time_t expiryDay);

private:
    Ui::KslVA *ui;
    bool m_bDrag;
    QIcon m_icon;
    QPoint m_mouseStartPoint;
    QPoint m_windowTopLeftPoint;
    QVBoxLayout *m_frameLayout;
    QTranslator *m_translator;
    VA::ActiveGuide *activeGuide;
};

#endif  // KSLVA_H
